# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
$Id: __init__.py 23713 2006-05-18 14:57:40Z roeder $
"""
__author__  = 'Maik Roeder'
__docformat__ = 'restructuredtext'

from global_symbols import *

from Products.GrufSpaces import GroupSpace

# CMF imports
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.utils import ContentInit

# Archetypes imports
from Products.Archetypes.public import process_types, listTypes

# Products imports
from Products.GrufSpaces.permissions import GroupSpace_addPermission
from Products.GrufSpaces.config import SKINS_DIR, GLOBALS, PROJECTNAME
from Products.GrufSpaces.types import *

registerDirectory(SKINS_DIR, GLOBALS)

def initialize(context):
    # Import types
    listOfTypes = listTypes(PROJECTNAME)
    content_types, constructors, ftis = process_types(listOfTypes,
                                                      PROJECTNAME)
    ContentInit('GroupSpace',
                content_types = content_types,
                permission = GroupSpace_addPermission,
                extra_constructors = constructors,
                fti = ftis,
                ).initialize(context)
