## Script (Python) "get_grufspaces_lfm"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=suite
##title=
##

class LFM:
    pass

class Areas:

    def test_delete_document_in_groupspace_area(self, path, document):
        self.suite.test_delete_content(path, document)

class Config:
    def test_areas_on(self):
        t = self.suite.getTest()
        t.open('/prefs_grufspaces_form'),
        t.click('use_groupspace_areas_on'),
        t.clickAndWait('form.button.Save'),
        t.verifyTextPresent('GrufSpaces configuration updated.'),
        t.verifyValue('use_groupspace_areas:int','on'),
        return t
        
    def test_areas_off(self):
        t = self.suite.getTest()
        t.open('/prefs_grufspaces_form')
        t.click('use_groupspace_areas_off')
        t.clickAndWait('form.button.Save')
        t.verifyTextPresent('GrufSpaces configuration updated.')
        t.verifyValue('use_groupspace_areas:int','off')
        return t
    
    def test_user_search_on(self):
        t = self.suite.getTest()
        t.open('/prefs_grufspaces_form')
        t.click('user_search_in_grufspaces_on')
        t.clickAndWait('form.button.Save')
        t.verifyTextPresent('GrufSpaces configuration updated.')
        t.verifyValue('user_search_in_grufspaces:int','on')
        return t
    
    def test_user_selection_on(self):
        t = self.suite.getTest()
        t.open('/prefs_grufspaces_form')
        t.click('user_search_in_grufspaces_off')
        t.clickAndWait('form.button.Save')
        t.verifyTextPresent('GrufSpaces configuration updated.')
        t.verifyValue('user_search_in_grufspaces:int','off')
        return t
    
    def test_group_search_on(self):
        t = self.suite.getTest()
        t.open('/prefs_grufspaces_form')
        t.click('group_search_in_grufspaces_on')
        t.clickAndWait('form.button.Save')
        t.verifyTextPresent('GrufSpaces configuration updated.')
        t.verifyValue('group_search_in_grufspaces:int','on')
        return t
    
    def test_group_selection_on(self):
        t = self.suite.getTest()
        t.open('/prefs_grufspaces_form')
        t.click('group_search_in_grufspaces_off')
        t.clickAndWait('form.button.Save')
        t.verifyTextPresent('GrufSpaces configuration updated.')
        t.verifyValue('group_search_in_grufspaces:int','off')
        return t

class GroupSpace:
    def test_add_group_folder_for_groupspaces(self, group):
        return self.suite.test_add_content('/', group)

    def test_add_document_to_groupspace(self, path, document):
        return self.suite.test_add_content(path, document)
    
    def test_add_document_to_groupspace_area(self, path, document):
        return self.suite.test_add_content(path, document)
    
    def test_add_document_to_member_folder(self, memberid, document):
        return self.suite.test_add_content('/Members/' + memberid, document)
    
    def test_share_groupspace(self, path):
        t = self.suite.getTest()
        t = self.suite.test_share(path, 'GroupMember', 'samplegroupmember', t=t)
        t = self.suite.test_share(path, 'GroupMember', 'othergroupmember', t=t)
        t = self.suite.test_share(path, 'GroupVisitor', 'samplegroupvisitor', t=t)
        t = self.suite.test_share(path, 'GroupAdmin', 'samplegroupadmin', t=t)
        t = self.suite.test_share(path, 'GroupLeader', 'samplegroupleader', t=t)
        return t
    
    def test_add_role_to_groupspace(self, path, memberid, role, notify=0):
        t = self.suite.getTest()
        t.open("%s/GroupSpace_rolesForm" % path)
        t.type('user_search_term',memberid)
        t.clickAndWait("perform_user_search")
        if notify:
            t.click("notify_user_assignment")
        t.select("user_collab_role", role)
        t.clickAndWait("form.button.Save")
        t.verifyTextPresent("Role assignment changed.")
        return t

lfm=LFM()
lfm.areas=Areas()
lfm.areas.suite=suite
lfm.config=Config()
lfm.config.suite=suite
lfm.groupspace=GroupSpace()
lfm.groupspace.suite=suite
return lfm
