# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase # side effect import. leave it here.
from Products.GrufSpaces.tests import grufspacestestcase

class TestGrufSpaces(grufspacestestcase.GrufSpacesTestCase):

    def testBasicInfo(self):
        self.setRoles(['Manager', 'Member']) 
        self.portal.invokeFactory('GroupSpace', 'gs')
        self.gs = self.portal.gs
        #self.gs = self.portal.gs        self.assertEquals('gs', self.gs.getId())
        self.assertEquals('GroupSpace', self.gs.Type())
        self.assertEquals('GroupSpace', self.gs.meta_type)
        self.gs.edit(title='GS', description='My Plone Group Space')
        self.assertEquals('GS', self.gs.Title())
        self.assertEquals('My Plone Group Space', self.gs.Description())
        pt = self.portal.portal_types
        fti = pt.getTypeInfo('GroupSpace')
        self.assertEquals('GroupSpace_listing', fti.getActionById('view'))
        self.assertEquals('base_edit', fti.getActionById('edit'))

if __name__ == '__main__':
    framework(descriptions=1, verbosity=1)
else:
    from unittest import TestSuite, makeSuite
    def test_suite():
        suite = TestSuite()
        suite.addTest(makeSuite(TestGrufSpaces))
        return suite

